# C++ 程序：使用多维数组添加两个矩阵

> 原文： [https://www.programiz.com/cpp-programming/examples/add-matrix](https://www.programiz.com/cpp-programming/examples/add-matrix)

#### 该程序采用`r * c`阶的两个矩阵并将其存储在二维数组中。 然后，程序将这两个矩阵相加并显示在屏幕上。

要理解此示例，您应该了解以下 [C++ 编程](/cpp-programming "C++ tutorial")主题：

*   [C++ 多维数组](/cpp-programming/multidimensional-arrays)
*   [C++ 数组](/cpp-programming/arrays)

* * *

在该程序中，要求用户输入行数`r`和列数`c`。 在此程序中，`r`和`c`的值应小于 100。

要求用户输入两个矩阵的元素（`r * c`顺序）。

然后，程序将这两个矩阵相加，将其保存在另一个矩阵（二维数组）中并将其显示在屏幕上。

## 示例：使用多维数组添加两个矩阵

```cpp
#include <iostream>
using namespace std;

int main()
{
    int r, c, a[100][100], b[100][100], sum[100][100], i, j;

    cout << "Enter number of rows (between 1 and 100): ";
    cin >> r;

    cout << "Enter number of columns (between 1 and 100): ";
    cin >> c;

    cout << endl << "Enter elements of 1st matrix: " << endl;

    // Storing elements of first matrix entered by user.
    for(i = 0; i < r; ++i)
       for(j = 0; j < c; ++j)
       {
           cout << "Enter element a" << i + 1 << j + 1 << " : ";
           cin >> a[i][j];
       }

    // Storing elements of second matrix entered by user.
    cout << endl << "Enter elements of 2nd matrix: " << endl;
    for(i = 0; i < r; ++i)
       for(j = 0; j < c; ++j)
       {
           cout << "Enter element b" << i + 1 << j + 1 << " : ";
           cin >> b[i][j];
       }

    // Adding Two matrices
    for(i = 0; i < r; ++i)
        for(j = 0; j < c; ++j)
            sum[i][j] = a[i][j] + b[i][j];

    // Displaying the resultant sum matrix.
    cout << endl << "Sum of two matrix is: " << endl;
    for(i = 0; i < r; ++i)
        for(j = 0; j < c; ++j)
        {
            cout << sum[i][j] << "  ";
            if(j == c - 1)
                cout << endl;
        }

    return 0;
} 
```

**输出**

```cpp
Enter number of rows (between 1 and 100): 2
Enter number of columns (between 1 and 100): 2

Enter elements of 1st matrix:
Enter element a11: -4
Enter element a12: 5
Enter element a21: 6
Enter element a22: 8

Enter elements of 2nd matrix:
Enter element b11: 3
Enter element b12: -9
Enter element b21: 7
Enter element b22: 2

Sum of two matrix is:
-1   -4
13   10 
```