# C++ 程序：查找三个数字中最大的数字

> 原文： [https://www.programiz.com/cpp-programming/examples/largest-number-among-three](https://www.programiz.com/cpp-programming/examples/largest-number-among-three)

#### 在此示例中，您将学习使用`if`，`if else`和嵌套的`if else`语句在三个数字中找到最大的数字。

要理解此示例，您应该了解以下 [C++ 编程](/cpp-programming "C++ tutorial")主题：

*   [C++ `if`，`if...else`和嵌套`if...else`](/cpp-programming/if-else)

* * *

在此程序中，要求用户输入三个数字。

然后，该程序在用户输入的三个数字中找出最大的数字，并显示适当的消息。

该程序可以以多种方式使用。

* * *

## 示例 1：使用`if`语句查找最大数

```cpp
#include <iostream>
using namespace std;

int main()
{    
    float n1, n2, n3;

    cout << "Enter three numbers: ";
    cin >> n1 >> n2 >> n3;

    if(n1 >= n2 && n1 >= n3)
    {
        cout << "Largest number: " << n1;
    }

    if(n2 >= n1 && n2 >= n3)
    {
        cout << "Largest number: " << n2;
    }

    if(n3 >= n1 && n3 >= n2) {
        cout << "Largest number: " << n3;
    }

    return 0;
}
```

**输出**

```cpp
Enter three numbers: 2.3
8.3
-4.2
Largest number: 8.3
```

* * *

## 示例 2：使用`if...else`语句查找最大数

```cpp
#include <iostream>
using namespace std;

int main()
{
    float n1, n2, n3;

    cout << "Enter three numbers: ";
    cin >> n1 >> n2 >> n3;

    if((n1 >= n2) && (n1 >= n3))
        cout << "Largest number: " << n1;
    else if ((n2 >= n1) && (n2 >= n3))
        cout << "Largest number: " << n2;
    else
        cout << "Largest number: " << n3;

    return 0;
}
```

**输出**

```cpp
Enter three numbers: 2.3
8.3
-4.2
Largest number: 8.3
```

* * *

## 示例 3：使用嵌套`if...else`语句查找最大数

```cpp
#include <iostream>
using namespace std;

int main()
{
    float n1, n2, n3;

    cout << "Enter three numbers: ";
    cin >> n1 >> n2 >> n3;

    if (n1 >= n2)
    {
        if (n1 >= n3)
            cout << "Largest number: " << n1;
        else
            cout << "Largest number: " << n3;
    }
    else
    {
        if (n2 >= n3)
            cout << "Largest number: " << n2;
        else
            cout << "Largest number: " << n3;
    }

    return 0;
}
```

**输出**

```cpp
Enter three numbers: 2.3
8.3
-4.2
Largest number: 8.3
```