# C++ 程序：显示斐波那契数列

> 原文： [https://www.programiz.com/cpp-programming/examples/fibonacci-series](https://www.programiz.com/cpp-programming/examples/fibonacci-series)

#### 在本文中，您将学习在 C++ 编程中打印斐波那契序列（最多 n 项，最多特定数目）。

要理解此示例，您应该了解以下 [C++ 编程](/cpp-programming "C++ tutorial")主题：

*   [C++ `for`循环](/cpp-programming/for-loop) 
*   [C++ `while`和`do...while`循环](/cpp-programming/do-while-loop)

* * *

斐波那契数列是一个系列，其中下一项是前两个项的总和。 斐波那契数列的前两个项是 0，然后是 1。

```cpp
The Fibonacci sequence: 0, 1, 1, 2, 3, 5, 8, 13, 21
```

* * *

## 示例 1：斐波那契数列，最多 n 个项

```cpp
#include <iostream>
using namespace std;

int main()
{
    int n, t1 = 0, t2 = 1, nextTerm = 0;

    cout << "Enter the number of terms: ";
    cin >> n;

    cout << "Fibonacci Series: ";

    for (int i = 1; i <= n; ++i)
    {
        // Prints the first two terms.
        if(i == 1)
        {
            cout << " " << t1;
            continue;
        }
        if(i == 2)
        {
            cout << t2 << " ";
            continue;
        }
        nextTerm = t1 + t2;
        t1 = t2;
        t2 = nextTerm;

        cout << nextTerm << " ";
    }
    return 0;
} 
```

**输出**

```cpp
Enter the number of terms: 10
Fibonacci Series: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 
```

* * *

## 示例 2：程序以生成一定数目的斐波那契数列

```cpp
#include <iostream>
using namespace std;

int main()
{
    int t1 = 0, t2 = 1, nextTerm = 0, n;

    cout << "Enter a positive number: ";
    cin >> n;

    // displays the first two terms which is always 0 and 1
    cout << "Fibonacci Series: " << t1 << ", " << t2 << ", ";

    nextTerm = t1 + t2;

    while(nextTerm <= n)
    {
        cout << nextTerm << ", ";
        t1 = t2;
        t2 = nextTerm;
        nextTerm = t1 + t2;
    }
    return 0;
} 
```

**输出**

```cpp
Enter a positive integer: 100
Fibonacci Series: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 
```