# C# Hello World - 您的第一个 C# 程序

> 原文： [https://www.programiz.com/csharp-programming/hello-world](https://www.programiz.com/csharp-programming/hello-world)

#### 在本教程中，我们将学习如何编写一个简单的 HelloWorld C# 中的程序。 这将使您熟悉 C# 程序的基本语法和要求。

HelloWorld 程序通常是我们使用一种新语言时看到的第一个程序。 它仅在输出画面上打印 **HelloWorld**。

该程序的目的是使我们熟悉编程语言的基本语法和要求。

* * *

##  C# 中的 HelloWorld

```cs
// Hello World! program
namespace HelloWorld
{
    class Hello {         
        static void Main(string[] args)
        {
            System.Console.WriteLine("Hello World!");
        }
    }
}
```

运行该程序时，输出为：

```cs
Hello World!
```

* * *

## 怎么样？ C# 中的程序有效吗？

让我们逐行分解程序。

1.  `// Hello World! Program`

    `//`表示 C# 中注释的开始。 注释不是由 C# 编译器执行的。

    它们旨在使开发人员更好地理解一段代码。 要了解有关 C# 中注释的更多信息，请访问 *C# 注释*。

2.  `namespace HelloWorld{...}`

    `namespace`关键字用于定义我们自己的名称空间。 在这里，我们创建一个名为`HelloWorld`的命名空间。

    只是将名称空间视为由类，方法和其他名称空间组成的容器。 要获得名称空间的详细概述，*请访问* [C# 命名空间](/csharp-programming/namespaces "C# namespaces")。

3.  `class Hello{...}`

    上面的语句在 C# 中创建一个名为-`Hello`的类。 由于 C# 是一种面向对象的编程语言，因此创建类对于执行该程序是必不可少的。

4.  `static void Main(string[] args){...}`

    `Main()`是 Hello 类的方法。 每个 C# 程序的执行都从`Main()`方法开始。 因此，C# 程序必须具有`Main()`方法。

    `Main()`方法的签名/语法为：

    ```cs
    static void Main(string[] args)
    {
        ...
    }
    ```

    我们将在后面的章节中详细了解这些方法。

5.  `System.Console.WriteLine("Hello World!");`

    现在，请记住，这是打印 **HelloWorld** 的代码。 转到输出屏幕。您将在后面的章节中详细了解其工作原理。

* * *

## 备选 HelloWorld 程序

这是写 HelloWorld 的另一种程序。

```cs
// Hello World! program
using System;

namespace HelloWorld
{
    class Hello {         
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
        }
    }
}
```

请注意，在这种情况下，我们在程序开始时编写了`using System;`。 通过使用这个，我们现在可以替换

```cs
System.Console.WriteLine("Hello World!");
```

与

```cs
Console.WriteLine("Hello World!");
```

这也是我们在以后的章节中将要使用的一种便利。

* * *

## 本文要记住的事情

*   每个 C# 程序都必须具有一个类定义。
*   程序的执行从`Main()`方法开始。
*   `Main()`方法必须在类定义内。

这只是一个将 C# 引入新手的简单程序。 如果您不了解本文中的某些内容，那也可以（即使我刚开始时也没有理解）。 随着本教程系列的进行，一切都会变得有意义。