# Java 程序：将二进制数转换为十进制，反之亦然

> 原文： [https://www.programiz.com/java-programming/examples/binary-decimal-convert](https://www.programiz.com/java-programming/examples/binary-decimal-convert)

#### 在此程序中，您将学习使用 Java 中的函数将二进制数转换为十进制数，反之亦然。

访问此页面以了解[如何将二进制数转换为十进制](http://www.wikihow.com/Convert-from-Binary-to-Decimal "Binary number to Decimal")。

## 示例 1：将二进制数转换为十进制的程序

```java
public class BinaryDecimal {

    public static void main(String[] args) {
        long num = 110110111;
        int decimal = convertBinaryToDecimal(num);
        System.out.printf("%d in binary = %d in decimal", num, decimal);
    }

    public static int convertBinaryToDecimal(long num)
    {
        int decimalNumber = 0, i = 0;
        long remainder;
        while (num != 0)
        {
            remainder = num % 10;
            num /= 10;
            decimalNumber += remainder * Math.pow(2, i);
            ++i;
        }
        return decimalNumber;
    }
}
```

运行该程序时，输出为：

```java
110110111 in binary = 439 in decimal
```

* * *

访问此页面以了解[如何将十进制数转换为二进制](http://www.wikihow.com/Convert-from-Decimal-to-Binary "Binary number to Decimal")。

## 示例 2：将十进制数转换为二进制的程序

```java
public class DecimalBinary {

    public static void main(String[] args) {
        int num = 19;
        long binary = convertDecimalToBinary(num);
        System.out.printf("%d in decimal = %d in binary", num, binary);
    }

    public static long convertDecimalToBinary(int n)
    {
        long binaryNumber = 0;
        int remainder, i = 1, step = 1;

        while (n!=0)
        {
            remainder = n % 2;
            System.out.printf("Step %d: %d/2, Remainder = %d, Quotient = %d\n", step++, n, remainder, n/2);
            n /= 2;
            binaryNumber += remainder * i;
            i *= 10;
        }
        return binaryNumber;
    }
}
```

When you run the program, the output will be:

```java
Step 1: 19/2, Remainder = 1, Quotient = 9
Step 2: 9/2, Remainder = 1, Quotient = 4
Step 3: 4/2, Remainder = 0, Quotient = 2
Step 4: 2/2, Remainder = 0, Quotient = 1
Step 5: 1/2, Remainder = 1, Quotient = 0
19 in decimal = 10011 in binary
```