# Java 程序：使用递归来计算幂

> 原文： [https://www.programiz.com/java-programming/examples/power-number-recursion](https://www.programiz.com/java-programming/examples/power-number-recursion)

#### 在此程序中，您将学习如何使用 Java 中的递归函数来计算数字的幂。

## 示例：使用递归计算幂的程序

```java
public class Power {

    public static void main(String[] args) {
        int base = 3, powerRaised = 4;
        int result = power(base, powerRaised);

        System.out.printf("%d^%d = %d", base, powerRaised, result);
    }

    public static int power(int base, int powerRaised) {
        if (powerRaised != 0)
            return (base * power(base, powerRaised - 1));
        else
            return 1;
    }
}
```

运行该程序时，输出为：

```java
3^4 = 81
```

在上面的程序中，您使用递归函数`power()`计算幂。

简而言之，递归函数将幂乘以基础乘以自身，即：

```java
3 * 3 * 3 * 3 = 81
```

Execution steps

| 迭代 | `power()` | `powerRaised` | 结果 |
| --- | --- | --- | --- |
| 1 | `power(3, 4)` | 4 | `3 * result2` |
| 2 | `power(3, 3)` | 3 | `3 * 3 * result3` |
| 3 | `power(3, 2)` | 2 | `3 * 3 * 3 * result4` |
| 4 | `power(3, 1)` | 1 | `3 * 3 * 3 * 3 * resultFinal` |
| 最后 | `power(3, 0)` | 0 | `3 * 3 * 3 * 3 * 1 = 81` |