# Java 程序：将毫秒转换为分钟和秒

> 原文： [https://www.programiz.com/java-programming/examples/milliseconds-minutes-seconds](https://www.programiz.com/java-programming/examples/milliseconds-minutes-seconds)

#### 在上面的程序中，您将学习如何在 Java 中将毫秒分别转换为分钟和秒。

## 示例 1：将毫秒分别转换为分钟和秒

```java
import java.util.concurrent.TimeUnit;

public class Milliseconds {

    public static void main(String[] args) {
        long milliseconds = 1000000;

        // long minutes = (milliseconds / 1000) / 60;
        long minutes = TimeUnit.MILLISECONDS.toMinutes(milliseconds);

        // long seconds = (milliseconds / 1000);
        long seconds = TimeUnit.MILLISECONDS.toSeconds(milliseconds);

        System.out.format("%d Milliseconds = %d minutes\n", milliseconds, minutes );
        System.out.println("Or");
        System.out.format("%d Milliseconds = %d seconds", milliseconds, seconds );

    }
}
```

运行该程序时，输出为：

```java
1000000 Milliseconds = 16 minutes
Or
1000000 Milliseconds = 1000 seconds
```

在上面的程序中，我们已经使用`toMinutes()`方法将给定的`毫秒`转换为分钟。 同样，我们使用`toSeconds()`方法将其转换为秒。

我们还可以使用基本数学将其转换为分钟和秒。

```java
Seconds = Milliseconds / 1000
```

分钟是

```java
Minutes = Seconds / 60
or
Minutes = (Milliseconds / 1000) / 60
```

* * *

## 示例 2：将毫秒转换为分钟和秒

```java
public class Milliseconds {

    public static void main(String[] args) {
        long milliseconds = 1000000;

        long minutes = (milliseconds / 1000) / 60;
        long seconds = (milliseconds / 1000) % 60;

        System.out.format("%d Milliseconds = %d minutes and %d seconds.", milliseconds, minutes, seconds);

    }
}
```

When you run the program, the output will be:

```java
1000000 Milliseconds = 16 minutes and 40 seconds.
```

在上面的程序中，我们使用了公式：

```java
Minutes = (Milliseconds / 1000) / 60
And
Remaining Seconds = (Milliseconds / 1000) % 60
```

首先，我们将分钟数简单地除以秒，然后用 60 除以分钟来计算分钟。

然后，我们通过将剩余秒数除以秒，然后将其除以 60 得到余数。