# Java 程序：重命名文件

> 原文： [https://www.programiz.com/java-programming/examples/rename-file](https://www.programiz.com/java-programming/examples/rename-file)

#### 在本教程中，我们将学习使用 Java 重命名文件。

[Java `File`](/java-programming/file "Java File Class")类提供`renameTo()`方法来更改文件名。 如果重命名操作成功，则返回`true`，否则返回`false`。

* * *

### 示例：使用 Java 重命名文件

```java
import java.io.File;

class Main {
  public static void main(String[] args) {

    // create a file object
    File file = new File("oldName");

    // create a file
    try {
      file.createNewFile();
    }
    catch(Exception e) {
      e.getStackTrace();
    }

    // create an object that contains the new name of file
    File newFile = new File("newName");

    // change the name of file
    boolean value = file.renameTo(newFile);

    if(value) {
      System.out.println("The name of the file is changed.");
    }
    else {
      System.out.println("The name cannot be changed.");
    }
  }
} 
```

在上面的示例中，我们创建了一个名为`file`的文件对象。 该对象保存有关指定文件路径的信息。

```java
File file = new File("oldName"); 
```

然后，我们使用指定的文件路径创建一个新文件。

```java
// create a new file with the specified path
file.createNewFile(); 
```

在这里，我们创建了另一个名为`newFile`的文件对象。 该对象保存有关指定文件路径的信息。

```java
File newFile = new File("newFile"); 
```

要更改文件名，我们使用了`renameTo()`方法。`newFile`对象指定的名称用于重命名`文件`对象指定的文件。

```java
file.renameTo(newFile); 
```

**如果操作成功**，则显示以下消息。

```java
The name of the file is changed. 
```

**如果操作无法成功**，则会显示以下消息。

```java
The name cannot be changed. 
```