# Java 程序：以列出目录中的文件

> 原文： [https://www.programiz.com/java-programming/examples/list-files](https://www.programiz.com/java-programming/examples/list-files)

#### 在本教程中，我们将学习列出目录中存在的所有文件和子目录。

[Java File](/java-programming/file "Java File Class") 类的`list()`方法用于列出目录中存在的所有文件和子目录。 它以字符串数组形式返回所有文件和目录。

* * *

### 示例：使用`list()`方法列出所有文件

```java
import java.io.File;

class Main {
  public static void main(String[] args) {

    // creates a file object
    File file = new File("C:\\Users\\Guest User\\Desktop\\Java File\\List Method");

    // returns an array of all files
    String[] fileList = file.list();

    for(String str : fileList) {
      System.out.println(str);
    }
  }
} 
```

**输出**

```java
.vscode
file.txt
directory
newFile.txt 
```

在上面的示例中，我们创建了一个名为`file`的文件对象。 该对象保存有关指定路径的信息。

```java
File file = new File("C:\\Users\\Guest User\\Desktop\\Java File\\List Method"); 
```

我们已经使用`list()`方法列出了指定路径中存在的所有文件和子目录。

```java
file.list(); 
```

**注意**：在指定路径时，我们使用了**双反斜杠**。 这是因为`\`字符在 Java 中用作**转义字符**。 因此，第一个反斜杠用作第二个的转义字符。