# Kotlin 程序：将毫秒转换为分钟

> 原文： [https://www.programiz.com/kotlin-programming/examples/milliseconds-minutes-seconds](https://www.programiz.com/kotlin-programming/examples/milliseconds-minutes-seconds)

#### 在上述程序中，您将学习在 Kotlin 中将毫秒分别转换为分钟和秒。

## 示例 1：将毫秒分别转换为分钟和秒

```kt
import java.util.concurrent.TimeUnit

fun main(args: Array<String>) {

    val milliseconds: Long = 1000000

    // long minutes = (milliseconds / 1000) / 60;
    val minutes = TimeUnit.MILLISECONDS.toMinutes(milliseconds)

    // long seconds = (milliseconds / 1000);
    val seconds = TimeUnit.MILLISECONDS.toSeconds(milliseconds)

    println("$milliseconds Milliseconds = $minutes minutes")
    println("Or")
    println("$milliseconds Milliseconds = $seconds seconds")
}
```

运行该程序时，输出为：

```kt
1000000 Milliseconds = 16 minutes
Or
1000000 Milliseconds = 1000 seconds
```

在上面的程序中，我们已经使用`toMinutes()`方法将给定的`毫秒`转换为分钟。 同样，我们使用`toSeconds()`方法将其转换为秒。

我们还可以使用基本数学将其转换为分钟和秒。

```kt
Seconds = Milliseconds / 1000
```

分钟是

```kt
Minutes = Seconds / 60
or
Minutes = (Milliseconds / 1000) / 60
```

* * *

## 示例 2：将毫秒转换为分钟和秒

```kt
fun main(args: Array<String>) {

    val milliseconds: Long = 1000000

    val minutes = milliseconds / 1000 / 60
    val seconds = milliseconds / 1000 % 60

    println("$milliseconds Milliseconds = $minutes minutes and $seconds seconds.")
}
```

When you run the program, the output will be:

```kt
1000000 Milliseconds = 16 minutes and 40 seconds.
```

在上面的程序中，我们使用了公式：

```kt
Minutes = (Milliseconds / 1000) / 60
And
Remaining Seconds = (Milliseconds / 1000) % 60
```

首先，我们将分钟数简单地除以秒，然后用 60 除以分钟来计算分钟。

然后，我们通过将剩余秒数除以秒，然后将其除以 60 得到余数。

以下是等效的 Java 代码：[将毫秒转换为分钟和秒的 Java 程序](/java-programming/examples/milliseconds-minutes-seconds "Java program to convert milliseconds to minutes and seconds")。