# Kotlin 程序：打印整数（由用户输入）

> 原文： [https://www.programiz.com/kotlin-programming/examples/print-integer](https://www.programiz.com/kotlin-programming/examples/print-integer)

#### 在此程序中，您将学习如何打印用户输入的整数。 整数存储在变量中，并分别使用`nextInt()`和`println()`函数打印到屏幕上。

### 示例 1：如何打印用户在 Kotlin 中使用扫描器输入的整数

```kt
import java.util.Scanner

fun main(args: Array<String>) {

    // Creates a reader instance which takes
    // input from standard input - keyboard
    val reader = Scanner(System.`in`)
    print("Enter a number: ")

    // nextInt() reads the next integer from the keyboard
    var integer:Int = reader.nextInt()

    // println() prints the following line to the output screen
    println("You entered: $integer")
}
```

运行该程序时，输出为：

```kt
Enter a number: 10
You entered: 10
```

* * *

在此示例中，创建了一个`Scanner`类的对象，即`阅读器`，它从`keyboard`（标准输入）获取用户的输入。

然后，`nextInt()`函数读取输入的整数，直到遇到换行符`\n (Enter)`为止。 然后将整数保存在类型为`Int`的变量`整数`中。

最后，`println()`函数使用字符串模板将`整数`打印到标准输出：计算机屏幕。

* * *

上面的程序与 Java 非常相似，没有样板类代码。 您可以在此处找到等效的 Java 代码：[打印整数的 Java 程序](/java-programming/examples/print-integer "How to print an Integer in Java")

* * *

### 示例 2：如何在不使用扫描器的情况下打印整数

```kt
fun main(args: Array<String>) {

    print("Enter a number: ")

    // reads line from standard input - keyboard
    // and !! operator ensures the input is not null
    val stringInput = readLine()!!

    // converts the string input to integer
    var integer:Int = stringInput.toInt()

    // println() prints the following line to the output screen
    println("You entered: $integer")
}
```

When you run the program, the output will be:

```kt
Enter a number: 10
You entered: 10
```

* * *

在上面的程序中，我们使用功能`readLine()`从键盘读取一行字符串。 由于`readLine()`也可以接受空值，因此 *!! 运算符*确保变量`stringInput`的值不为空。

然后，使用函数`toInt()`将存储在`stringInput`中的字符串转换为整数值，并存储在另一个变量`整数`中。

最后，使用`println()`将整数打印到输出屏幕上。