# Kotlin 程序：打印数组

> 原文： [https://www.programiz.com/kotlin-programming/examples/print-array](https://www.programiz.com/kotlin-programming/examples/print-array)

#### 在此程序中，您将学习在 Kotlin 中打印给定数组元素的不同技术。

## 示例 1：使用`For`循环打印数组

```kt
fun main(args: Array<String>) {
    val array = intArrayOf(1, 2, 3, 4, 5)

    for (element in array) {
        println(element)
    }
}
```

运行该程序时，输出为：

```kt
1
2
3
4
5
```

在上面的程序中，`for-each`循环用于迭代给定数组`array`。

它访问`array`中的每个`element`并使用`println()`打印。

* * *

## 示例 2：使用标准库数组打印数组

```kt
import java.util.Arrays

fun main(args: Array<String>) {
    val array = intArrayOf(1, 2, 3, 4, 5)

    println(Arrays.toString(array))
}
```

When you run the program, the output will be:

```kt
[1, 2, 3, 4, 5]
```

在上述程序中，使用`Arrays.toString()`函数的`for`循环已替换为单行代码。

如您所见，这提供了干净的输出，而没有任何额外的代码行。

* * *

## 示例 3：打印多维数组

```kt
import java.util.Arrays

fun main(args: Array<String>) {
    val array = arrayOf(intArrayOf(1, 2),
            intArrayOf(3, 4),
            intArrayOf(5, 6, 7))

    println(Arrays.deepToString(array))
}
```

When you run the program, the output will be:

```kt
[[1, 2], [3, 4], [5, 6, 7]]
```

在上述程序中，由于数组中的每个元素都包含另一个数组，因此仅使用`Arrays.toString()`即可打印元素的地址（嵌套数组）。

为了从内部数组中获取数字，我们只需要另一个函数`Arrays.deepToString()`。 这使我们得到数字 1、2，依此类推，我们正在寻找。

此函数也适用于 3 维数组。

以下是等效的 Java 代码：[打印数组的 Java 程序](/java-programming/examples/print-array "Java program to print an array")