# 如何在 Python 中获取当前日期和时间？

> 原文： [https://www.programiz.com/python-programming/datetime/current-datetime](https://www.programiz.com/python-programming/datetime/current-datetime)

#### 在本文中，您将学习使用 Python 获取今天的日期以及当前的日期和时间。 我们还将使用`strftime()`方法将日期和时间格式化为不同的格式。

您可以采用多种方法来获取当前日期。 我们将使用[日期时间](/python-programming/datetime)模块的`date`类来完成此任务。

* * *

## 示例 1：Python 获取今天的日期

```py
from datetime import date

today = date.today()
print("Today's date:", today) 
```

在这里，我们从`datetime`模块导入了`date`类。 然后，我们使用`date.today()`方法获取当前的本地日期。

顺便说一句，`date.today()`返回一个`date`对象，该对象在上述程序中分配给了`today`变量。 现在，您可以使用[`strftime()`](/python-programming/datetime/strftime)方法创建一个以不同格式表示日期的字符串。

* * *

## 示例 2：格式不同的当前日期

```py
from datetime import date

today = date.today()

# dd/mm/YY
d1 = today.strftime("%d/%m/%Y")
print("d1 =", d1)

# Textual month, day and year	
d2 = today.strftime("%B %d, %Y")
print("d2 =", d2)

# mm/dd/y
d3 = today.strftime("%m/%d/%y")
print("d3 =", d3)

# Month abbreviation, day and year	
d4 = today.strftime("%b-%d-%Y")
print("d4 =", d4) 
```

当您运行程序时，输出将类似于：

```py
d1 = 16/09/2019
d2 = September 16, 2019
d3 = 09/16/19
d4 = Sep-16-2019
```

* * *

如果需要获取当前日期和时间，可以使用`datetime`模块的`datetime`类。

## 示例 3：获取当前日期和时间

```py
from datetime import datetime

# datetime object containing current date and time
now = datetime.now()

print("now =", now)

# dd/mm/YY H:M:S
dt_string = now.strftime("%d/%m/%Y %H:%M:%S")
print("date and time =", dt_string) 
```

在这里，我们使用`datetime.now()`来获取当前日期和时间。 然后，我们使用`strftime()`创建一个以另一种格式表示日期和时间的字符串。